import { EditorState, EditorSelection } from '@codemirror/next/state';
import { highlighter } from '@codemirror/next/highlight';
import { history } from '@codemirror/next/history';
import { csharp } from "./lang-csharp.js";
import highlighterSpec from "./highlighter-spec.js";
import lineSeparator from "./line-separator.js";
import keymap from "./keymap.js";
import { sendChangesToServer } from "./server/send-changes.js";
import { sendCursorToServer } from "./server/send-cursor.js";
import { slowUpdateLinter } from "./server/slow-update-linter.js";
export function createState(connection, options) {
  return EditorState.create({ ...(options.initialText ? {
      doc: options.initialText
    } : {}),
    ...(options.initialCursorOffset ? {
      selection: EditorSelection.single(options.initialCursorOffset)
    } : {}),
    extensions: [EditorState.indentUnit.of(4), EditorState.lineSeparator.of(lineSeparator), history(), keymap, csharp(), highlighter(highlighterSpec), sendChangesToServer(connection), sendCursorToServer(connection), slowUpdateLinter(connection, options)]
  });
}