import { EditorView } from '@codemirror/next/view';
import type { ServerOptions, Language } from '../interfaces/protocol';
import type { SlowUpdateOptions } from '../interfaces/slow-update';
import type { Connection } from './connection';
interface EditorOptions<TExtensionServerOptions, TSlowUpdateExtensionData> {
    readonly language?: Language;
    readonly initialText?: string;
    readonly initialCursorOffset?: number;
    readonly on?: {
        readonly textChange?: (getText: () => string) => void;
        readonly connectionChange?: {
            (event: 'open', e: Event): void;
            (event: 'error', e: ErrorEvent): void;
            (event: 'close', e: CloseEvent): void;
        };
        readonly serverError?: (message: string) => void;
    } & SlowUpdateOptions<TSlowUpdateExtensionData>;
    readonly initialServerOptions?: TExtensionServerOptions;
}
export declare class Editor<TExtensionServerOptions, TSlowUpdateExtensionData> {
    #private;
    constructor(container: HTMLElement, connection: Connection<TExtensionServerOptions, TSlowUpdateExtensionData>, options: EditorOptions<TExtensionServerOptions, TSlowUpdateExtensionData>);
    getCodeMirrorView(): EditorView;
    getText(): string;
    getLanguage(): Language;
    setLanguage(value: Language): Promise<void>;
    setServerOptions(value: ServerOptions): Promise<void>;
    destroy(destroyOptions?: {
        readonly keepCodeMirror?: boolean;
    }): void;
}
export {};
