// import { SelfDebug } from './main/self-debug';
import { Connection } from "./main/connection.js";
import { Editor } from "./main/editor.js";
export default function mirrorsharp(container, options) {
  // const selfDebug = options.selfDebugEnabled ? new SelfDebug() : null;
  const connection = new Connection(options.serviceUrl
  /*, selfDebug*/
  );
  const editor = new Editor(container, connection
  /*, selfDebug*/
  , options);
  return Object.freeze({
    getCodeMirrorView: () => editor.getCodeMirrorView(),
    getText: () => editor.getText(),
    // setText: (text: string) => editor.setText(text),
    getLanguage: () => editor.getLanguage(),
    setLanguage: value => editor.setLanguage(value),
    setServerOptions: value => editor.setServerOptions(value),

    destroy(destroyOptions) {
      editor.destroy(destroyOptions);
      connection.close();
    }

  });
}